***********************
* PRJCHECK.PRG
***********************
* Grundlage ist Original (based on) GROK von Mark J Carew 25/10/04 05:18
**********************************************************************************
* Es ist jedem erlaubt, das Programm an seine Bedrfnisse anzupassen.
* Bei Fehlerbeseitigungen oder Verbesserungen wre es schn, mir diese nderungen
* zukommen zu lassen (info@ciju.de)
* Everyone can change this program to his needs.
* It would be nice to send error removals or improvments to me (info@ciju.de)
**********************************************************************************
* Parameter:
* "D" ,"E"   Language Deutsch, Englisch (german, english)
* ( oder Einstellungen / or settings in PRJCHECK.INI
*
**********************************************************************************
* Wolfgang Ciriack
* 22.07.2014   Version 1.0.1  ARRAY statt DBF
*                             DC_TXT* - Funktionen fr Datei-Operationen
*                             Option NOSTATICS, dann werden keine Static Functionen und Proceduren abgespeichert
*                             OPENFILES u. BREAKPOINT - Eintrag bei XPJ-Dateien bercksichtigt
*                             Anzahl Parameter der Func/Proc
*                             Auswertungsanzeige als Array-Browse, sortierbar, Datei mit Auswahl zu ffnen, Export nach Excel
* 23.07.2014   Version 1.0.2  Hits wg. Kommentarende gendert
* 23.07.2014   Version 1.0.3  Parametermittlung bei Hits eingebaut
*                             Hits fr fast gleichnamige Fkt. entfernt (Test und MyTest)
* 23.07.2014   Version 1.0.4  Hits-Ermittlung korrigiert
*                             Defines fr Version, Info und Vorfunktionszch.
* 24.07.2014   Version 1.0.5  Abspeichern der Funktion mit alltrim(), damit XY() und XY () gefunden werden
* 24.07.2014   Version 1.0.6  Option Funktionen als String als Hits werten neu, extra Array-Eintrag
*                             Bei Ergebnis Suche nach Funktionen eingebaut, kosmetische Anpassungen
*                             Export nach XLS, CSV und DBF
*                             Weitere Korrekturen an der Hit-Erkennung
* 24.07.2014   Version 1.0.7  Ausnahmen FKT_EXCEPTIONS zugefgt, bei der Hitsuche string und funktion mit gleichem Namen abgefangen
*                             Das Freeze der 3 linken Spalten in der Ergebnisansicht entfernt
*                             Filter fr Hits und Parameterfilter eingebaut, default fr Hits in Strings auf .T. gesetzt
* 28.07.2014   Version 1.0.8  Parametererkennung (Herausnahme von {...}-Blcken) verbessert, Info ber Error nur noch 1x pro PRG
*                             Treffer bei static functions nur noch in entsprechender Datei
* 31.07.2014   Version 1.0.9  Parametererkennung berarbeitet, APPEXIT in Ausnahmen hinzugefgt
*                             Fatal ERROR durch Funktion atrepl(...) beseitigt (trat beim ca. 450. Aufruf in der Parameterkennung auf, Speicherleck ???)
*                             Erkennung von DLLFUNCTION und LL_FUNCTION,LL_PROCEDURE (List&Label) hinzugefgt
*                             Funktionserkennung verbessert: Letzte Zeile ohne CRLF
*                             Export im Array-Format und Laden von Array-Dateien in Ergebnisansicht
*                             ffnen von Export-Datei nur noch bei Excel-Format
*                             Parametererkennung-Logging als Option einebaut
*                             Neustart ohne Programm zu verlassen
* 01.08.2014   Version 1.1.0  Mehrsprachigkeit eingefgt, bisher Parameter beim Aufruf "D", oder "E", lang_offset 0=deutsch, 100=englisch
*                             Exportdateien fangen mit ProjChk_ an
*                             Umbenennung Programm in Projekt Checker
*                             INI-File fr Optionen und Pfad erstellt
**********************************************************************************
*  Bekannte Probleme bei der Parametererkennung / Known problemes with parameter check:
*  - Kommas in Strings eines Parameters, comma in string parameters
*  - Funktions ber mehrere Zeilen (;) / function in multiple rows (;)
**********************************************************************************
#INCLUDE "common.ch"
#include "AppEvent.ch"
#include "dbfdbe.ch"
#include "cdxdbe.ch"
#INCLUDE "dcdialog.CH"
#include "dcmsg.ch"
***********************
#PRAGMA LIBRARY( "DCLIPX.LIB" )
#PRAGMA LIBRARY( "XBTBASE1.LIB" )
#PRAGMA LIBRARY( "XBTBASE2.LIB" )
***********************
#define VERSION "1.1.0"
#define INFOSTRING "Wolfgang Ciriack, 2014"
***********************
#define CRLF chr( 13 ) + chr( 10 )
#define CR chr( 13 )
#define LF chr( 10 )
#define FKTSTRZCHVOR '"(&'+"'"
#define FKTSTRZCHNACH '"('+"'"
#define BEFOREFKTCHARS " ,{(;!=@+-><|:"
#define FKT_EXCEPTIONS  {"MAIN","APPSYS","DBESYS","ERRORSYS","APPEXIT"}

*** Grok-Positions ***
#define P_FUNC   1
#define P_FART   2
#define P_FILE   3
#define P_LINE   4
#define P_HITS   5
#define P_INFO   6
#define P_ANZP   7
#define P_ERRO   8
#define P_STRH   9
#define ARR_LEN  9
#define GROK_LEER  {{"","","",0,0,"",0,"",0}}

*** Options for files
#define ART_PRGX 1
#define ART_PRGA 2
#define ART_XPJX 3
#define ART_XPJA 4
#define ART_SPEZ 5

*** Options for export
#define EXP_XLS  1
#define EXP_CSV  2
#define EXP_DBF  3
#define EXP_ARR  4

**** StringsNo. for Language ****
#define MYMSG_FILEAUS      100
#define MYMSG_ALLPRG       101
#define MYMSG_SELPRG       102
#define MYMSG_ALLXPJ       103
#define MYMSG_SELXPJ       104
#define MYMSG_FROMFILE     105
#define MYMSG_OPTIONEN     106
#define MYMSG_NOSTATIC     107
#define MYMSG_STRHITS      108
#define MYMSG_PRAMLOG      109
#define MYMSG_STATUS       110
#define MYMSG_START        111
#define MYMSG_RESTART      112
#define MYMSG_RESULT       113
#define MYMSG_DLG1TITLE    114
#define MYMSG_VERZ         115
#define MYMSG_RESULT_FKT   116
#define MYMSG_RESULT_ZL    117
#define MYMSG_RESULT_T1    118
#define MYMSG_RESULT_T2    119
#define MYMSG_RESULT_T3    120
#define MYMSG_STATUS_1     121
#define MYMSG_STATUS_2     122
#define MYMSG_STRSEARCH    123
#define MYMSG_FUNKTION     124
#define MYMSG_ZEILE        125
#define MYMSG_HITS         126
#define MYMSG_HITSSTR      127
#define MYMSG_PARA_ERR     128
#define MYMSG_EXP_OPEN     129
#define MYMSG_LOAD         130
#define MYMSG_SAVEDAS      131
#define MYMSG_OPENFILE     132
#define MYMSG_ASKFILE      133
#define MYMSG_DLG3TITLE    134
#define MYMSG_ASKARRAY     135
#define MYMSG_ERROR        136
#define MYMSG_LISTFILE     137
#define MYMSG_DOPPELT      138
#define MYMSG_BEENDEN      139
***********************
static lang_offset
static aGrok
static aProgsToCheck
static cPrg
static cShortProg
static nAsteriskSlash
static nLineNo
static nSlashAsterisk
static lNoStatics
static nFilesGesamt
static cStatus
static nTotalLines
static lFktStringToHits
static lLogging
static cLogfile
static hitnr
*****************************************************
PROCEDURE AppSys
RETURN
*****************************************************
procedure main(cLang)
local aPrgs:={}
local Getlist:={}, oGroup1, oGroup2, oGroup3, oPrGes,oStatus, oBtOk, oB1
local nArt:=ART_XPJA, cVerz:=CurDrive()+":\"+CurDir(), lstarted:=.F., firsttime:=.T.

if file(cVerz+"\Prjcheck.ini")
   cLang := DC_INIREAD('PRJCHECK.INI','GLOBAL','Language')
   nArt := val(DC_INIREAD('PRJCHECK.INI','GLOBAL','SelNum'))
   lNoStatics := iif(DC_INIREAD('PRJCHECK.INI','GLOBAL','NoStatics')="YES",.T.,.F.)
   lLogging := iif(DC_INIREAD('PRJCHECK.INI','GLOBAL','ParamLogging')="YES",.T.,.F.)
   lFktStringToHits := iif(DC_INIREAD('PRJCHECK.INI','GLOBAL','FuncInStringsHits')="YES",.T.,.F.)
   cVerz:=DC_INIREAD('PRJCHECK.INI','GLOBAL','Path')
endif
if Valtype(lNoStatics)<>"L"
   lNoStatics:=.F.
endif
if Valtype(lLogging)<>"L"
   lLogging:=.F.
endif
if Valtype(lFktStringToHits)<>"L"
   lFktStringToHits:=.T.
endif
if empty(cVerz)
   cVerz:=CurDrive()+":\"+CurDir()
endif
cVerz:=substr(cVerz+space(255),1,255)

do case
case clang=="E"
   lang_offset:=100
   DC_LangSet(DCLANG_ENGLISH)
otherwise
   ** default german
   lang_offset:=0
   DC_LangSet(DCLANG_GERMAN)
endcase

set date SYSTEM
DC_GetPopupCaption( {"12.Marlett", "u", 1 } )
DC_Gui(.T.)
DC_BrowseSort( { GRA_CLR_BLACK, ;
                 GraMakeRGBColor({186,214,235}) , ;
                 GRA_CLR_WHITE, ;
                 GraMakeRGBColor({57,136,193}), ;
                 NIL, ;
                 NIL, ;
                 GRA_CLR_WHITE, ;
                 GraMakeRGBColor({113,170,213}) })


cLogfile:=""
aGrok:={}
aProgsToCheck:={}
*******
InitVars()
*******

@ 1,1 DCGROUP oGroup1             CAPTION my_langMsg(MYMSG_FILEAUS) SIZE 40,7
@ 1,1 DCRADIO nArt VALUE ART_PRGX  PROMPT my_langMsg(MYMSG_ALLPRG)   PARENT oGroup1
@ 2,1 DCRADIO nArt VALUE ART_PRGA  PROMPT my_langMsg(MYMSG_SELPRG)   PARENT oGroup1
@ 3,1 DCRADIO nArt VALUE ART_XPJX  PROMPT my_langMsg(MYMSG_ALLXPJ)   PARENT oGroup1
@ 4,1 DCRADIO nArt VALUE ART_XPJA  PROMPT my_langMsg(MYMSG_SELXPJ)   PARENT oGroup1
@ 5,1 DCRADIO nArt VALUE ART_SPEZ  PROMPT my_langMsg(MYMSG_FROMFILE) PARENT oGroup1 OBJECT oB1

@ 8.5,1 DCGROUP oGroup2           CAPTION my_langMsg(MYMSG_OPTIONEN) SIZE 40,5
@ 1,1 DCCHECKBOX lNoStatics       CAPTION my_langMsg(MYMSG_NOSTATIC) PARENT oGroup2
@ 2,1 DCCHECKBOX lFktStringToHits CAPTION my_langMsg(MYMSG_STRHITS)  PARENT oGroup2
@ 3,1 DCCHECKBOX lLogging         CAPTION my_langMsg(MYMSG_PRAMLOG) PARENT oGroup2

@16,1 DCSAY my_langMsg(MYMSG_VERZ) SAYSIZE 0
@17,1 DCGET cVerz GETSIZE 80,1 POPUP {|c| DC_Popdir(c) }

@1,44 DCGROUP oGroup3 CAPTION my_langMsg(MYMSG_STATUS) SIZE 40,15
@1,1 DCMULTILINE cStatus OBJECT oStatus SIZE 38,13.5 EDITPROTECT {|| .T. } PARENT oGroup3 NOHORIZSCROLL

@18.5, 1 DCPROGRESS oPrGes  SIZE 82, 1 ;
      TYPE XBPSTATIC_TYPE_RECESSEDBOX ;
      COLOR GRA_CLR_DARKBLUE,GRA_CLR_BACKGROUND ;
      PERCENT ;
      PERCENTCOLOR GRA_CLR_WHITE ;
      DYNAMIC ;
      EVERY 5 ;
      MAXCOUNT nFilesGesamt*2

@20.5,1 DCSAY INFOSTRING SAYSIZE 30,0.8 FONT "8.Arial"


@20,70 DCPUSHBUTTON CAPTION {|| my_langMsg(iif(firsttime,MYMSG_START,MYMSG_RESTART)) } SIZE 15,1.2 OBJECT oBtOk ;
       ACTION {|| iif(!firsttime, ;
                     ( ASize(aPrgs,0), DC_Getprogress(oPrGes, 0, nFilesGesamt), InitVars(), dc_getrefresh(Getlist) ), ;
                       firsttime:=.F.), ;
                  iif(chkEingaben(nArt,alltrim(cVerz),@aPrgs), ;
                     ( lstarted:=.T., dc_getrefresh(Getlist), iif(lLogging, ;
                                                              ( cLogfile:=alltrim(cVerz)+"\Logfile_"+charonly("0123456789",dtoc(date()))+".txt", strfile("Parameterlogging"+CRLF,cLogfile)),;
                                                              nil), ;
                       StartVorgang(aPrgs,oPrGes,oStatus), lstarted:=.F., AuswertungDlg(cVerz), dc_getrefresh(Getlist) ), ;
                     nil) } ;
       WHEN {|| !lstarted }

@20,54 DCPUSHBUTTON CAPTION my_langMsg(MYMSG_RESULT) SIZE 15,1.2 ;
       ACTION {||  AuswertungDlg(cVerz) } ;
       WHEN {|| !lstarted }

@20,38 DCPUSHBUTTON CAPTION my_langMsg(MYMSG_BEENDEN) SIZE 15,1.2 ;
       ACTION {||  DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList) } ;
       WHEN {|| !lstarted }

DCREAD GUI ;
   TITLE my_langMsg(MYMSG_DLG1TITLE)+"  "+VERSION ;
   MODAL ;
   SETAPPWINDOW ;
   SETFOCUS @oB1 ;
   FIT

return
***************************************************************************
function InitVars()

nFilesGesamt:=0
ASize(aGrok,0)
nTotalLines := 0
ASize(aProgsToCheck,0)
cStatus:=""
hitnr:=0
return nil
***************************************************************************
function chkEingaben(nArt,v_verz,aPrgs)
local aFiles, aThisXpj := {}, nLen, i

do case
case nArt=ART_PRGX
   aFiles:= directory(v_verz+"\*.prg")
   nLen := len(aFiles)
   aPrgs:={}
   FOR i := 1 TO nLen
      AAdd(aPrgs,{v_verz+"\"+aFiles[i][1]})
   next
case nArt=ART_XPJX
   aFiles := directory(v_verz+"\*.xpj")
   nLen := len(aFiles)
   FOR i := 1 TO nLen
      xpjPrgsArray(v_verz+"\"+aFiles[i][1],aThisXpj)
   NEXT
   aPrgs := aThisXpj
case nArt=ART_SPEZ
   if file(v_verz+"\Dateiliste.txt")
      aPrgs:=GetFromTxtFile(v_verz,my_langMsg(MYMSG_LISTFILE))
   endif
case nArt=ART_PRGA
   *************
   aPrgs:=AuswahlDlg(v_verz,"*.prg")
   *************
case nArt=ART_XPJA
   *************
   aPrgs:=AuswahlDlg(v_verz,"*.xpj")
   *************
endcase
return !empty(aPrgs)
***************************************************************************
function AuswahlDlg(cVerz,cArt)
local Getlist:={}, i, l, lExit, oBrowse, aRet:={}, oBtOk
local aFiles:= directory(cVerz+"\"+cArt)
local aAuswahl:={}

l:=len(aFiles)
for i:=1 to l
   AAdd(aAuswahl,{cVerz+"\"+aFiles[i][1],.F.})
next
if len(aAuswahl)=0
   AAdd(aAuswahl,{"",.F.})
endif

@1,1 DCBROWSE oBrowse ;
      DATA aAuswahl ;
      SIZE 50,20 ;
      FIT ;
      NOHSCROLL ;
      ITEMSELECTED {|w| w:=DC_GetColArray(2,oBrowse), DC_GetColArray(2,oBrowse,!w), dc_getrefresh(oBtOk), oBrowse:refreshCurrent()}

DCBROWSECOL DATA {|| iif(DC_GetColArray(2,oBrowse), chr(97),"") } HEADER "Sel." ;
            FONT "12.Marlett" ;
            ALIGN XBPALIGN_HCENTER+XBPALIGN_VCENTER ;
            WIDTH 1.5 ;
            PARENT oBrowse
DCBROWSECOL ELEMENT 1 HEADER dc_LangMsg(DCMSG_FILE) PARENT oBrowse WIDTH 50

@22,30 DCPUSHBUTTON CAPTION dc_LangMsg(DCMSG_OK) SIZE 12,1.2 OBJECT oBtOk ACTION {||  DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } WHEN {|| AScan(aAuswahl,{|a| a[2]=.T.})>0 }
@22,17 DCPUSHBUTTON CAPTION dc_LangMsg(DCMSG_CANCEL) SIZE 12,1.2 ACTION {||  DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList) }

DCREAD GUI ;
   TO lExit ;
   TITLE my_langMsg(MYMSG_FILEAUS) ;
   MODAL ;
   SETAPPWINDOW ;
   FIT

if lExit
   l:=len(aAuswahl)
   for i:=1 to l
      if aAuswahl[i][2]
         if ".XPJ" $ upper(aAuswahl[i][1])
            ***********
            xpjPrgsArray(aAuswahl[i][1],aRet,cVerz+"\")
            ***********
         else
            AAdd(aRet, {aAuswahl[i][1]})
         endif
      endif
   next
endif
return aRet
***************************************************************************
function GetFromTxtFile(verz,datei)
local cLine, nHandle, aRet:={}

nHandle:=DC_TxtOpen(verz+"\"+datei)
IF nHandle > 0
   do while !DC_Txteof(nHandle)
      cLine := upper(DC_TxtLine(nHandle))
      if file(verz+"\"+cLine)
         if ".XPJ" $ cLine
            xpjPrgsArray(verz+"\"+cLine,aRet,verz+"\")
         elseif ".PRG" $ cLine
            if AScan(aRet, cLine)=0
               AAdd(aRet,{verz+"\"+cLine})
            endif
         endif
      endif
      DC_Txtskip(nHandle,1)
   enddo
   DC_Txtclose(nHandle)
endif
return aRet
***************************************************
function StartVorgang(aPrgs, oBar, oStatus)
local i, cString, nHandle, nStart, nZwZ, nEnde, l, p

nStart:=seconds()
nFilesGesamt:= len(aPrgs)
dc_getrefresh(oBar)

FOR i:=1 TO nFilesGesamt
   DC_Getprogress(oBar, i, nFilesGesamt*2)
   cPrg := upper(alltrim(aPrgs[i][1]))
   aadd(aProgsToCheck,cPrg)
   nLineNo := 0
   nSlashAsterisk := 0
   nHandle:=DC_TxtOpen(cPrg)
   IF nHandle > 0
      do while !DC_Txteof(nHandle)
         cString := DC_TxtLine(nHandle)
         cString := strtran(cString,chr(09),space(4))
         nTotalLines ++
         **********
         processPrg(cString,oStatus)
         **********
         DC_Txtskip(nHandle,1)
      enddo
      DC_Txtclose(nHandle)
   endif
next
nZwZ:=seconds()
*********
updateHitCount(oBar,oStatus)
*********
l:=len(FKT_EXCEPTIONS)
for i:=1 TO l
   if (p:=AScan(aGrok, {|a| a[P_FUNC]==FKT_EXCEPTIONS[i]}))>0
      aGrok[p][P_HITS]:=9999
   endif
next

DC_Getprogress(oBar, nFilesGesamt*2, nFilesGesamt*2)
nEnde:=seconds()

cStatus:=my_langMsg(MYMSG_RESULT_FKT)+str(len(aGrok))+CRLF+cStatus
cStatus:=my_langMsg(MYMSG_RESULT_ZL)+str(nTotalLines,10,0)+CRLF+cStatus
cStatus:=my_langMsg(MYMSG_RESULT_T1)+sectotime(nZwZ-nStart,.T.)+CRLF+cStatus
cStatus:=my_langMsg(MYMSG_RESULT_T2)+sectotime(nEnde-nZwZ,.T.)+CRLF+cStatus
cStatus:=my_langMsg(MYMSG_RESULT_T3)+sectotime(nEnde-nStart,.T.)+CRLF+cStatus
dc_getrefresh(oStatus)
return nil
****************************************************
function xpjPrgsArray(cXpjName,aThisXpj,cVerz)
local nScan
local cXpjString
local nHandle

DEFAULT cVerz TO ""

nHandle:=DC_TxtOpen(cXpjName)
IF nHandle <> -1
   * what are the prgs in this xpj
    do while !DC_Txteof(nHandle)
      cXpjString := DC_TxtLine(nHandle)
      cXpjString := upper(alltrim(cXpjString))
      IF at(".PRG",cXpjString) > 0 .and. at("OPENFILES",cXpjString)=0  .and. at("BREAKPOINT",cXpjString)=0
         IF AT("/" + "/",cXpjString) == 0
            IF empty(aThisXpj)
               aadd(aThisXpj,{cVerz+cXpjString})
            else
               nScan := ;
               aScan(aThisXpj,{|e|e[1]==cVerz+cXpjString })
               IF nScan == 0
                  aadd(aThisXpj,{cVerz+cXpjString})
               ENDIF
            ENDIF
         ENDIF
      ENDIF
      DC_Txtskip(nHandle,1)
   enddo
   DC_Txtclose(nHandle)
ENDIF
return aThisXpj
*****************************************************
function processPrg(cString,oStatus)
local cFirstTwo, cFunct, cFunction
local cUpper, cUpperString
local nFunctionCol
local cFArt:="", p, nParam

cUpper := upper(strtran(cString,CR,""))
cUpper := strtran(cUpper,LF,"")
cUpperString := alltrim(cUpper)
cFirstTwo := left(cUpperString,2)
nLineNo ++
if cUpperString == "*" .OR. cFirstTwo == "/" + "/"  .OR. cFirstTwo == "**"
else
   nFunctionCol := at("FUNC",cUpperString)
   if nFunctionCol < 1
      nFunctionCol := at("PROC",cUpperString)
   endif
   if nSlashAsterisk == 0
      nSlashAsterisk := at('/*',cUpperString)
   endif
   * time to turn off slash asterisk
   if nSlashAsterisk > 0
      nAsteriskSlash := at('*/',cUpperString)
      if nAsteriskSlash > 0
         nSlashAsterisk := 0
         nAsteriskSlash := 0
      endif
   endif
   * if commenting is off
   IF nSlashAsterisk == 0
      do case
      case nFunctionCol == 1 .or. nFunctionCol == 8 .or. nFunctionCol == 4
         cFunction := cUpperString
         nParam:=FktParamCheck(cFunction,1)
         if at("(",cFunction) > 0
            cFunct := substr(cFunction,1,at("(",cFunction)-1)
         elseif at("//",cFunction) > 0
            cFunct := substr(cFunction,1,at("//",cFunction)-1)
         else
            cFunct := cFunction
         endif
         cFArt:=""
         if "STATIC" $ cFunct
             cFArt:="static "
             if  lNoStatics
                return nil
             endif
         endif
         if "DLLFUNC" $ cFunct
             cFArt:="dllfunc"
         endif
         cFunct := strtran(cFunct,"STATIC ","")
         cFunct := strtran(cFunct,"LL_FUNCTION ","")
         cFunct := strtran(cFunct,"LL_PROCEDURE ","")
         cFunct := strtran(cFunct,"DLLFUNCTION ","")
         cFunct := strtran(cFunct,"FUNCTION ","")
         cFunct := strtran(cFunct,"PROCEDURE ","")
         cFunct := strtran(cFunct,"FUNC ","")
         cFunct := strtran(cFunct,"PROC ","")
         cFunct := ltrim(cFunct)

         if "FUNC" $ cFunct .or. "PROC" $ cFunct
            ** checken, ob jetzt immer noch func, proc enthalten ist,
            ** dann ist es keine gesuchte Funktion/Procedure
            return nil
         endif
         if substr(cFunct,1,1) == "*"
            return nil
         endif

         if AScan(aGrok,{|a| a[P_FUNC]==cFunct})>0 .and. empty(cFArt)
            cStatus:=my_langMsg(MYMSG_DOPPELT)+alltrim(cFunct)+CRLF+cStatus
            dc_getrefresh(oStatus)
         else
            cStatus:=cFArt+alltrim(cFunct)+CRLF+cStatus
            dc_getrefresh(oStatus)
            AAdd(aGrok,ARRAY(ARR_LEN))
            p:=len(aGrok)
            aGrok[p][P_FUNC]:=alltrim(cFunct)
            aGrok[p][P_FART]:=cFArt
            aGrok[p][P_FILE]:=cPrg
            aGrok[p][P_LINE]:=nLineNo
            aGrok[p][P_HITS]:=0
            aGrok[p][P_INFO]:=""
            aGrok[p][P_ANZP]:=nParam
            aGrok[p][P_ERRO]:=""
            aGrok[p][P_STRH]:=0
         ENDIF
         nSlashAsterisk := 0
         nAsteriskSlash := 0
      endcase
   ENDIF
endif
return nil
***********************************************
function FktParamCheck(cFunction, art)
local retw:=0, pAuf, cT, pZu, cParameter, aP

pAuf:=at("(",cFunction)
if pAuf>0
   cT:=substr(cFunction,pAuf)
   if art=1
      ** Definition einer Funktion/Procedur
      pZu:=at(")",cT)
      if pZu>0
         cParameter:=charrem(" ",substr(cT,1,pZu))
         if len(cParameter)=2
            ** ()
         elseif at(",",cParameter)=0
            retw:=1
         else
            aP:=dc_tokenarray(cParameter,",")
            retw:=len(aP)
         endif
      endif
   else
      ** Ermittlung der Hits
      WriteLog(alltrim(str(++hitnr))+" HIT:      "+cFunction+":"+CRLF)
      retw:=ChkParaInString(cT)
      WriteLog(" Count: **"+alltrim(str(retw))+"**"+CRLF)
   endif
endif
return retw
***********************************************
function ChkParaInString(cPString)
local retw:=0, nSp:=1, cT, p:=1, p2, p3, cTmp
local lAMode:=.F.
local nAnzKa:=0, nAnzKz:=0, nAnzDiff:=0

if substr(charrem(" ",cPString),1,2)=="()"
   return retw
endif

WriteLog("PCHK:"+cPString)

cPString:=substr(cPString,2)
do while p>0
   p:=at(",",cPString,nSp)
   if p>0
      cT:=substr(cPString,nSp,p-nSp)
      ** Start fr nchste Suche
      nSp:=p+1
   else
      ** Rest auswerten
      cT:=substr(cPString,nSp)
   endif
   if lAMode=.F.
      *** Arrays {...} entfernen
      if (p2:=at("{",cT))>0
         if (p3:=at("}",cT))>0
            cTmp:=substr(cT,1,p2-1)+substr(cT,p3+1)
            cT:=cTmp
         else
            lAMode=.T.
         endif
      endif
   elseif (p2:=at("}",cT))>0
      cT:=substr(cT,p2+1)
      lAMode:=.F.
   endif
   if !lAMode
      *** Klammerpaare (...) entfernen
      nAnzKa:=Numat("(",cT)+nAnzDiff
      nAnzKz:=Numat(")",cT)
      nAnzDiff:=nAnzKa-nAnzKz

      if nAnzDiff>=0
         if (p2:=at(")",cT))>0
            if p2<at("(",cT)
               ** Ende Funktion gefunden
               retw++
               return retw
            endif
         endif
      endif

      if nAnzDiff=0
         ** Parameter gefunden
         retw++
      elseif nAnzDiff<0
         ** Ende Fkt. gefunden
         retw++
         return retw
      endif
   endif
enddo
return retw
***********************************************
function updateHitCount(oBar, oStatus)
local cString, cUpperString
local nFunctionCol, nHandleCfg
local nLen, nPtr

nLen := len(aProgsToCheck)
cStatus:=my_langMsg(MYMSG_STATUS_1)+CRLF+cStatus
FOR nPtr := 1 TO nLen
   DC_Getprogress(oBar, nPtr+nFilesGesamt, nFilesGesamt*2)
   cPrg := aProgsToCheck[nPtr]
   cShortProg := substr(strtran(cPrg,".PRG",""),rat("\",cPrg)+1)
   cStatus:=my_langMsg(MYMSG_STATUS_2)+cShortProg+CRLF+cStatus
   dc_getrefresh(oStatus)
   nHandleCfg:=DC_TxtOpen(cPrg)
   IF nHandleCfg > 0
      do while !DC_Txteof(nHandleCfg)
         cString := DC_TxtLine(nHandleCfg)
         cString := strtran(cString,chr(09),space(4))
         cUpperString := upper(alltrim(cString))
         if cUpperString=="*"
         else
            * look for slash Asterisk
            if nSlashAsterisk == 0
               nSlashAsterisk := at("/*",cUpperString)
            ENDIF
            * time to turn off slash asterisk
            if nSlashAsterisk > 0
               nAsteriskSlash := at("*/",cUpperString)
               if nAsteriskSlash > 0
                  nSlashAsterisk := 0
                  nAsteriskSlash := 0
               endif
            endif
            if substr(cUpperString,1,1) == "*"
               ** Kommentarzeile
            else
               * if commenting is off
               IF nSlashAsterisk == 0
                  * assumes that only one function is found per line
                  * we are realy looking for no hits
                  nFunctionCol := at("LL_FUNCTION ",cUpperString)
                  if nFunctionCol < 1
                     nFunctionCol := at("LL_PROCEDURE ",cUpperString)
                     if nFunctionCol < 1
                        nFunctionCol := at("DLLFUNCTION ",cUpperString)
                        if nFunctionCol < 1
                           nFunctionCol := at("FUNC ",cUpperString)
                           if nFunctionCol < 1
                              nFunctionCol := at("FUNCTION ",cUpperString)
                              if nFunctionCol < 1
                                 nFunctionCol := at("PROC ",cUpperString)
                                 if nFunctionCol < 1
                                    nFunctionCol := at("PROCEDURE ",cUpperString)
                                 endif
                              endif
                           endif
                        endif
                     endif
                  endif
                  do case
                  case nFunctionCol == 1
                  case nFunctionCol == 8
                  otherwise
                     * looking for functions only
                     IF at("(",cUpperString) > 0 .or. (lFktStringToHits .and. !empty(CharOnly(FKTSTRZCHVOR,cUpperString)))
                        lookForHits(cUpperString,cPrg)
                        sleep(0)
                     ENDIF
                  endcase
               endif
            endif
         endif
         DC_Txtskip(nHandleCfg,1)
      enddo
      DC_Txtclose(nHandleCfg)
      nSlashAsterisk := 0
      nAsteriskSlash := 0
   endif
   sleep(1)
NEXT
return nil
*************************************************************
function lookForHits(cString,cPrg)
local i, l:=len(aGrok), cFunction, nParam, p, zchvor, zchnach
local cTn, lf, nogo, ii, anz

for i:=1 to l
   cFunction := aGrok[i][P_FUNC]

   if aGrok[i][P_FART]="static " .and. cPrg<>aGrok[i][P_FILE]
      ** bei static function nur Datei durchsuchen, in der auch die Static deklariert ist
   else
      lf:=len(cFunction)
      ** z.B. Funktion markiere() und string "markieren" in einer Zeile,
      ** daher Anzahl des Auftretens des Funktionsnamens testen
      anz:=NumAt(cFunction,cString)
      for ii:=1 to anz
         IF (p:=atnum(cFunction,cString,ii)) > 0
            ** hier findet er auch einen Treffer bei Test() und MYTest()
            ** daher prfen das Zeichen vor der Funktion prfen
            ** Zch vor und nach Fkt. checken
            cTn:=alltrim(substr(cString,p+lf))
            if (zchnach:=substr(cTn,1,1))=="("
               ** Funktion gefunden "("
               nogo:=.F.
               if p>1
                  ** stand nicht am Anfang der Zeile
                  zchvor:=substr(cString,p-1,1)
                  if !(zchvor $ BEFOREFKTCHARS) .and. !empty(zchvor)
                     if lFktStringToHits .and. zchvor $ FKTSTRZCHVOR
                        * Funktion als String gefunden (evtl. Makro- oder Thread-Aufruf
                        aGrok[i][P_STRH]++
                        if at(cShortProg,aGrok[i][P_INFO]) == 0
                           aGrok[i][P_INFO] += cShortProg + "|"
                        endif
                     endif
                     nogo:=.T.
                  endif
               endif
               if !nogo
                  aGrok[i][P_HITS]++
                  if at(cShortProg,aGrok[i][P_INFO]) == 0
                     aGrok[i][P_INFO] += cShortProg + "|"
                  endif
                  nParam:=FktParamCheck(substr(cString,p),2)
                  if nParam<>aGrok[i][P_ANZP]
                     if at(cShortProg,aGrok[i][P_ERRO]) == 0
                        aGrok[i][P_ERRO]+=cShortProg + ": PaCo. "+alltrim(str(nParam))+"<>"+alltrim(str(aGrok[i][P_ANZP]))+"|"
                     endif
                  endif
               endif
            elseif lFktStringToHits .and. (zchnach $ FKTSTRZCHNACH)
               if p>1
                  zchvor:=substr(cString,p-1,1)
                  if zchvor $ FKTSTRZCHVOR
                     * Funktion als String gefunden (evtl. Makro- oder Thread-Aufruf
                     aGrok[i][P_STRH]++
                     if at(cShortProg,aGrok[i][P_INFO]) == 0
                        aGrok[i][P_INFO] += cShortProg + "|"
                     endif
                  endif
               endif
            endif
         endif
      next
   endif
next
return nil
*************************************************************
procedure AuswertungDlg(cVerz)
local Getlist:={}, oBrowse, oPopupMenu
local bSortCol:={|a,n,o| dc_getbrowArray(oBrowse, Sortarr(aGrok, oBrowse:GetColumn(n):cargo[3])),Suchstr:=space(15), DC_GetRefresh(Getlist), SetAppFocus(oSuch) }
local bColorBl:={|| iif(DC_GetColArray(P_HITS,oBrowse)=0 .and. DC_GetColArray(P_STRH,oBrowse)=0,{GRA_CLR_RED,nil},{nil,nil})}
local oSuch, Suchstr:=space(15), aRef[2], lhits:=.F., lpara:=.F.
local aPP:={{XBP_PP_COMPOUNDNAME, "10.Arial" }, ;
           {XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK }, ;
           {XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE}, ;
           {XBP_PP_HILITE_FGCLR, GRA_CLR_BLACK }, ;
           {XBP_PP_HILITE_BGCLR, GraMakeRGBColor({255,204,153}) } }

if empty(aGrok)
   aGrok:=LoadFromArr(cVerz,.T.)
   if empty(aGrok)
      return
   endif
endif

aGrok:=Sortarr(aGrok,P_FUNC)

DCSUBMENU oPopupMenu PROMPT "Export" OWNERDRAW
DCMENUITEM 'Format XLS' PARENT oPopupMenu ACTION {|| ErstelleExport(cVerz, EXP_XLS) }
DCMENUITEM SEPARATOR PARENT oPopupMenu
DCMENUITEM 'Format CSV' PARENT oPopupMenu ACTION {|| ErstelleExport(cVerz, EXP_CSV) }
DCMENUITEM SEPARATOR PARENT oPopupMenu
DCMENUITEM 'Format DBF' PARENT oPopupMenu ACTION {|| ErstelleExport(cVerz, EXP_DBF) }
DCMENUITEM SEPARATOR PARENT oPopupMenu
DCMENUITEM 'Format ARR' PARENT oPopupMenu ACTION {|| ErstelleExport(cVerz, EXP_ARR) }

@0.7, 1 DCSAY my_langMsg(MYMSG_STRSEARCH)
@0.5,17 DCGET Suchstr PICTURE "@K !!!!!!!!!!!!!!!" ;
      KEYBLOCK {|a,b,o| dc_browseAutoSeek(a,o,oBrowse,aGrok,P_FUNC,,,,,,.T.) } ;
      LOSTFOCUS {|| Suchstr:=space(15), DC_GetRefresh(Getlist,"IDSUCH") } ;
      OBJECT oSuch ;
      GETID "IDSUCH"

@0.7,45 DCSAY "Filter:" SAYSIZE 0
@0.5,52 DCCHECKBOX lhits CAPTION " Hits+SHits=0" ACTION {|| dc_getbrowArray(oBrowse,SetFilter(lhits,lpara)),oBrowse:refreshAll(), SetAppFocus(oBrowse)}
@0.5,67 DCCHECKBOX lpara CAPTION " Param.Error"  ACTION {|| dc_getbrowArray(oBrowse,SetFilter(lhits,lpara)),oBrowse:refreshAll(), SetAppFocus(oBrowse)}

@2,1 DCBROWSE oBrowse ;
      DATA aGrok ;
      SIZE 100,23 ;
      CURSORMODE XBPBRW_CURSOR_ROW ;
      PRESENTATION aPP ;
      FIT MAX dc_GetWorkArea()[3] ;
      ITEMSELECTED {|| ShowDetails(DC_GetColArray(nil,oBrowse))}

DCBROWSECOL ELEMENT P_FUNC HEADER my_langMsg(MYMSG_FUNKTION) PARENT oBrowse WIDTH 20 SORT bSortCol LEFTBUTTON DEFAULT CARGO P_FUNC COLOR bColorbl
DCBROWSECOL ELEMENT P_FART HEADER "Typ" PARENT oBrowse WIDTH 7 COLOR bColorbl
DCBROWSECOL ELEMENT P_ANZP HEADER "Para." PARENT oBrowse WIDTH 4 COLOR bColorbl
DCBROWSECOL DATA {|x| x:=DC_GetColArray(P_FILE,oBrowse), substr(x,1,10)+"..."+substr(x,rat("\",x))} HEADER dc_langmsg(DCMSG_FILE) PARENT oBrowse WIDTH 20 SORT bSortCol LEFTBUTTON CARGO P_FILE COLOR bColorbl
DCBROWSECOL ELEMENT P_LINE HEADER my_langMsg(MYMSG_ZEILE) PARENT oBrowse WIDTH 4 COLOR bColorbl
DCBROWSECOL ELEMENT P_HITS HEADER my_langMsg(MYMSG_HITS) PARENT oBrowse WIDTH 4 SORT bSortCol LEFTBUTTON CARGO P_HITS COLOR bColorbl
DCBROWSECOL ELEMENT P_STRH HEADER my_langMsg(MYMSG_HITSSTR) PARENT oBrowse WIDTH 4 SORT bSortCol LEFTBUTTON CARGO P_STRH COLOR bColorbl
DCBROWSECOL ELEMENT P_INFO HEADER "Information" PARENT oBrowse WIDTH 30 COLOR bColorbl
DCBROWSECOL ELEMENT P_ERRO HEADER my_langMsg(MYMSG_PARA_ERR) PARENT oBrowse WIDTH 30 COLOR bColorbl

@26,62 DCPUSHBUTTON CAPTION dc_langMsg(DCMSG_OK) SIZE 12,1.2 ACTION {||  DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }
@26,40 DCPUSHBUTTON CAPTION my_langMsg(MYMSG_EXP_OPEN) SIZE 20,1.2 ACTION {|a,b,o| oPopupMenu:PopUp(o:setparent(), o:CurrentPos()) }
@26,22 DCPUSHBUTTON CAPTION my_langMsg(MYMSG_LOAD) SIZE 16,1.2 ACTION {|| dc_getbrowArray(oBrowse,LoadFromArr(cVerz,.F.)),dc_getrefresh(Getlist), SetAppFocus(oBrowse) }


DCREAD GUI ;
   TITLE my_langMsg(MYMSG_RESULT) ;
   MODAL ;
   SETAPPWINDOW ;
   FIT ;
   HANDLER MyBrwHandler REFERENCE aRef ;
   EVAL {|| aRef[1]:=oBrowse, aRef[2]:=oSuch }

return
***************************************************************
FUNCTION MyBrwHandler( nEvent, mp1, mp2, oXbp, GetList, oDialog, aRef)
local oBrw:=aRef[1], oS:=aRef[2]

IF nEvent == xbeP_Keyboard .and. (SetAppFocus()==oBrw)
   if mp1>=32 .and. mp1<165
      SetAppFocus(oS)
      PostAppEvent(xbeP_Keyboard,mp1,mp2,oS)
   endif
elseif nEvent == xbeM_Wheel .and. (SetAppFocus()<>oBrw)
   SetAppFocus(oBrw)
   PostAppEvent(xbeM_Wheel,mp1,mp2,oBrw)
ENDIF
RETURN DCGUI_NONE
***************************************************************
static function SetFilter(lhits,lpara)
local aRet:={}, bed1:={|| .T.}, bed2:={|| .T.}
local i, l:=len(aGrok)

if !lhits .and. !lpara
   return aGrok
endif
if lhits
   bed1:={|a| a[P_HITS]=0 .and. a[P_STRH]=0 }
endif
if lpara
   bed2:={|a| !empty(a[P_ERRO]) }
endif
for i:=1 to l
   if Eval(bed1,aGrok[i]) .and. Eval(bed2,aGrok[i])
      AAdd(aRet, aGrok[i])
   endif
next
if empty(aRet)
   aRet:=GROK_LEER
endif
return aRet
***************************************************************
static function Sortarr(aD,sp)
local aRet:=aD

if sp=P_FUNC
   aRet:=ASort(aD,,, {|aX,aY| upper(aX[P_FUNC]) < upper(aY[P_FUNC]) } )
elseif sp=P_FILE
   aRet:=ASort(aD,,, {|aX,aY| upper(aX[P_FILE])+upper(aX[P_FUNC]) < upper(aY[P_FILE])+upper(aY[P_FUNC]) } )
elseif sp=P_HITS
   aRet:=ASort(aD,,, {|aX,aY| str(aX[P_HITS])+upper(aX[P_FUNC])+upper(aX[P_FILE]) < str(aY[P_HITS])+upper(aY[P_FUNC])+upper(aY[P_FILE]) } )
elseif sp=P_STRH
   aRet:=ASort(aD,,, {|aX,aY| str(aX[P_STRH])+upper(aX[P_FUNC])+upper(aX[P_FILE]) < str(aY[P_STRH])+upper(aY[P_FUNC])+upper(aY[P_FILE]) } )
endif
return aRet
******************************************************
procedure ShowDetails(aSatz)
local Getlist:={}, bEdit:={|| .T. }

@ 1, 1 DCSAY my_langMsg(MYMSG_FUNKTION)    GET aSatz[P_FUNC] GETSIZE 40,1 EDITPROTECT bEdit SAYSIZE 10,1
@ 2, 1 DCSAY "Typ"  GET aSatz[P_FART] GETSIZE 8,1 SAYSIZE 10,1
@ 3, 1 DCSAY "Parameter" GET aSatz[P_ANZP] PICT "999999" GETSIZE 10,1 SAYSIZE 10,1
@ 4, 1 DCSAY dc_langmsg(DCMSG_FILE)   GET aSatz[P_FILE] GETSIZE 80,1 SAYSIZE 10,1
@ 5, 1 DCSAY my_langMsg(MYMSG_ZEILE)  GET aSatz[P_LINE] PICT "999999" GETSIZE 10,1 SAYSIZE 10,1
@ 6, 1 DCSAY my_langMsg(MYMSG_HITS)  GET aSatz[P_HITS] PICT "999999" GETSIZE 10,1 SAYSIZE 10,1
@ 7, 1 DCSAY my_langMsg(MYMSG_HITSSTR)  GET aSatz[P_STRH] PICT "999999" GETSIZE 10,1 SAYSIZE 10,1
@ 8, 1 DCSAY "Info"        SAYSIZE 10,1
@ 8,12.2 DCMULTILINE aSatz[P_INFO] SIZE 80,4
@12.5,1 DCSAY "Para.Error" SAYSIZE 10,1
@12.5,12.2 DCMULTILINE aSatz[P_ERRO] SIZE 80,4

@18,50 DCPUSHBUTTON CAPTION dc_langMsg(DCMSG_OK) SIZE 12,1.2 ACTION {||  DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }
@18,30 DCPUSHBUTTON CAPTION my_langMsg(MYMSG_OPENFILE) SIZE 15,1.2 ACTION {|| DC_SpawnUrl(aSatz[P_FILE])} ;

DCREAD GUI ;
   TITLE 'Details' ;
   MODAL ;
   SETAPPWINDOW ;
   FIT

return
****************************************************
procedure ErstelleExport(cVerz,art)
local lstatus:=.F., endung, datei, al
local cExportfile:=alltrim(cVerz)+"\ProjChk_"+charonly("0123456789",dtoc(date()))+"_"+charrem(":",time())
local lAsk4open:=.F.

do case
case art=EXP_XLS
   endung:=".xls"
   lstatus:=DC_Array2Excel(cExportfile+endung, {aGrok})
   lAsk4open:=.T.
case art=EXP_CSV
   endung:=".csv"
   ** DC_Array2CSV ndert in aGrok alle Felder zu C, daher AClone !
   lstatus:=DC_Array2CSV(cExportfile+".csv", AClone(aGrok))
   lAsk4open:=.T.
case art=EXP_DBF
   endung:=".dbf"
   datei:=cExportfile+endung
   if file(datei)
      filedelete(datei)
   endif
   dbcreate(datei, ;
            {{"funcname","C",45,0},;
             {"functyp","C",7,0},;
             {"anzparam","N",6,0},;
             {"program","C",255,0},;
             {"prgrow","N",6,0},;
             {"hits","N",6,0},;
             {"hitsstr","N",6,0},;
             {"info","C",255,0},;
             {"error","C",255,0}} )

   if file(datei)
      use (datei) new exclusive
      al:=alias()

      AEval(aGrok,{|a,n| DC_AddRec(), ;
                         (al)->funcname:=aGrok[n][P_FUNC], ;
                         (al)->functyp :=aGrok[n][P_FART], ;
                         (al)->anzparam:=aGrok[n][P_ANZP], ;
                         (al)->program :=aGrok[n][P_FILE], ;
                         (al)->prgrow  :=aGrok[n][P_LINE], ;
                         (al)->hits    :=aGrok[n][P_HITS], ;
                         (al)->hitsstr :=aGrok[n][P_STRH], ;
                         (al)->info    :=substr(aGrok[n][P_INFO],1,255), ;
                         (al)->error   :=substr(aGrok[n][P_ERRO],1,255) })

      (al)->(dbclosearea())
      lstatus:=.T.
   endif
case art=EXP_ARR
   endung:=".arr"
   lstatus:=DC_Array_W(aGrok, cExportfile+endung)
endcase
if lstatus
   DC_MsgBox(my_langMsg(MYMSG_SAVEDAS)+cExportfile+endung)
   if lAsk4open
      if DC_Alert(my_langMsg(MYMSG_ASKFILE), {dc_langmsg(DCMSG_YES),dc_langmsg(DCMSG_NO)})=1
         DC_SpawnUrl(cExportfile+endung)
      endif
   endif
else
   DC_MsgBox(my_langMsg(MYMSG_ERROR))
endif
return
***********************************************************************
procedure WriteLog(txt)

if lLogging
   strfile(txt,cLogfile,.T.)
endif
return
***********************************************************************
function LoadFromArr(cVerz,lask)
local retw:=GROK_LEER, f, aTmp, answ:=1

if lask
   answ:=DC_Alert(my_langMsg(MYMSG_ASKARRAY), {dc_langmsg(DCMSG_YES),dc_langmsg(DCMSG_NO)})
endif
if answ=1
   f:=dc_popfile("*.arr",cVerz,"ProjChk_*.arr",my_langMsg(MYMSG_DLG3TITLE))
   if !empty(f)
      aTmp:=DC_Array_R(f)
      if Valtype(aTmp)=="A"
         if len(aTmp)>0
            retw:=aTmp
         endif
      endif
   endif
endif
return retw
***********************************************************************
function my_langMsg(nr)

nr+=lang_offset

do case
******** DEUTSCH *************
case nr=MYMSG_FILEAUS         ; return 'Auswahl Dateien'
case nr=MYMSG_ALLPRG          ; return 'Alle PRG-Dateien aus Verzeichnis'
case nr=MYMSG_SELPRG          ; return 'Ausgewhlte PRG-Dateien...'
case nr=MYMSG_ALLXPJ          ; return 'Alle XPJ-Dateien aus Verzeichnis'
case nr=MYMSG_SELXPJ          ; return 'Ausgewhlte XPJ-Dateien...'
case nr=MYMSG_FROMFILE        ; return 'Aus Datei DATEILISTE.TXT'
case nr=MYMSG_OPTIONEN        ; return 'Optionen'
case nr=MYMSG_NOSTATIC        ; return ' keine STATIC Funkt./Proced. listen'
case nr=MYMSG_STRHITS         ; return ' Funktion in String als Treffer zhlen (z.B."myfunk")'
case nr=MYMSG_PRAMLOG         ; return ' Logdatei fr Parametererkennung'
case nr=MYMSG_STATUS          ; return 'Status'
case nr=MYMSG_START           ; return 'Start'
case nr=MYMSG_RESTART         ; return 'Neustart'
case nr=MYMSG_RESULT          ; return 'Ergebnis'
case nr=MYMSG_DLG1TITLE       ; return 'Projekt Checker '
case nr=MYMSG_VERZ            ; return 'Verzeichnis'
case nr=MYMSG_RESULT_FKT      ; return "Anzahl Fkt.: "
case nr=MYMSG_RESULT_ZL       ; return "Zeilen gesamt: "
case nr=MYMSG_RESULT_T1       ; return "Zeit Funktionen: "
case nr=MYMSG_RESULT_T2       ; return "Zeit Treffer: "
case nr=MYMSG_RESULT_T3       ; return "Zeit Gesamt: "
case nr=MYMSG_STATUS_1        ; return 'Ermittle Anzahl Func/Proc-Aufrufe.. '
case nr=MYMSG_STATUS_2        ; return "Suche in "
case nr=MYMSG_STRSEARCH       ; return "Funktionssuche:"
case nr=MYMSG_FUNKTION        ; return "Funktion"
case nr=MYMSG_ZEILE           ; return "Zeile"
case nr=MYMSG_HITS            ; return "Treffer"
case nr=MYMSG_HITSSTR         ; return "Str.-Tref."
case nr=MYMSG_PARA_ERR        ; return "Parameter-Fehler"
case nr=MYMSG_EXP_OPEN        ; return "Export und ffnen..."
case nr=MYMSG_LOAD            ; return "Laden..."
case nr=MYMSG_SAVEDAS         ; return "Gesichert als: "
case nr=MYMSG_RESULT          ; return 'Ergebnis'
case nr=MYMSG_OPENFILE        ; return "ffne Datei"
case nr=MYMSG_ASKFILE         ; return "Gespeicherte Datei ffnen ?"
case nr=MYMSG_DLG3TITLE       ; return "ARR-Datei laden"
case nr=MYMSG_ASKARRAY        ; return "Gespeichertes Array-Ergebnis laden ?"
case nr=MYMSG_ERROR           ; return "Fehler aufgetreten"
case nr=MYMSG_LISTFILE        ; return "Dateiliste.txt"
case nr=MYMSG_DOPPELT         ; return 'doppelt: '
case nr=MYMSG_BEENDEN         ; return 'Beenden'
******** ENGLISH  (Offset 100) *************
case nr=MYMSG_FILEAUS   +100  ; return 'File selection'
case nr=MYMSG_ALLPRG    +100  ; return 'all PRG-files from directory'
case nr=MYMSG_SELPRG    +100  ; return 'selected PRG-files...'
case nr=MYMSG_ALLXPJ    +100  ; return 'all XPJ-files from directory'
case nr=MYMSG_SELXPJ    +100  ; return 'selected XPJ-files...'
case nr=MYMSG_FROMFILE  +100  ; return 'files from file FILELIST.TXT'
case nr=MYMSG_OPTIONEN  +100  ; return 'Options'
case nr=MYMSG_NOSTATIC  +100  ; return ' no listing of STATIC func./proc.'
case nr=MYMSG_STRHITS   +100  ; return ' count function in string as hit (f.e."myfunc")'
case nr=MYMSG_PRAMLOG   +100  ; return ' logfile for parameter scanning'
case nr=MYMSG_STATUS    +100  ; return 'Status'
case nr=MYMSG_START     +100  ; return 'Start'
case nr=MYMSG_RESTART   +100  ; return 'Restart'
case nr=MYMSG_RESULT    +100  ; return 'Result'
case nr=MYMSG_DLG1TITLE +100  ; return 'Project Checker '
case nr=MYMSG_VERZ      +100  ; return 'Directory'
case nr=MYMSG_RESULT_FKT+100  ; return "Count Func.: "
case nr=MYMSG_RESULT_ZL +100  ; return "Rows total: "
case nr=MYMSG_RESULT_T1 +100  ; return "Time for functions: "
case nr=MYMSG_RESULT_T2 +100  ; return "Time for hits: "
case nr=MYMSG_RESULT_T3 +100  ; return "Time total: "
case nr=MYMSG_STATUS_1  +100  ; return 'Getting counts of func/proc calls.. '
case nr=MYMSG_STATUS_2  +100  ; return "search in "
case nr=MYMSG_STRSEARCH +100  ; return "Function search:"
case nr=MYMSG_FUNKTION  +100  ; return "Function"
case nr=MYMSG_ZEILE     +100  ; return "RowNo"
case nr=MYMSG_HITS      +100  ; return "Hits"
case nr=MYMSG_HITSSTR   +100  ; return "Str.-Hits"
case nr=MYMSG_PARA_ERR  +100  ; return "Parameter-Error"
case nr=MYMSG_EXP_OPEN  +100  ; return "Export and open..."
case nr=MYMSG_LOAD      +100  ; return "Load..."
case nr=MYMSG_SAVEDAS   +100  ; return "Saved as: "
case nr=MYMSG_RESULT    +100  ; return 'Result'
case nr=MYMSG_OPENFILE  +100  ; return "Open file"
case nr=MYMSG_ASKFILE   +100  ; return "Open a saved file ?"
case nr=MYMSG_DLG3TITLE +100  ; return "Load a ARR-file"
case nr=MYMSG_ASKARRAY  +100  ; return "Open a saved Array-Result ?"
case nr=MYMSG_ERROR     +100  ; return "An error occurred"
case nr=MYMSG_LISTFILE  +100  ; return "filelist.txt"
case nr=MYMSG_DOPPELT   +100  ; return 'twice: '
case nr=MYMSG_BEENDEN   +100  ; return 'Quit'
******** ************
endcase
return "?????"

































